package demo.fz;

import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlElementWrapper;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlRootElement;

@JacksonXmlRootElement(localName = "xml")
public class AccountMoveReq {
    private String mchntCd;
    private String traceNo;
    private String srcFasSsn;
    private String srcFasDate;
    
    
	@JacksonXmlElementWrapper(localName = "list")
    @JacksonXmlProperty(localName = "item")
    private List<AccountMoveReqItem> list;
	
	
    private String reserved;
    private String signature;


    public String generateClearText() {
        List<String> excludeFieldList = new ArrayList<>();
        excludeFieldList.add("signature");
        excludeFieldList.add("list");
        return ClearTextUtil.generateClearText(this, excludeFieldList);
    }

	public String getMchntCd() {
		return mchntCd;
	}


	public void setMchntCd(String mchntCd) {
		this.mchntCd = mchntCd;
	}


	public String getTraceNo() {
		return traceNo;
	}


	public void setTraceNo(String traceNo) {
		this.traceNo = traceNo;
	}


	public String getSrcFasSsn() {
		return srcFasSsn;
	}


	public void setSrcFasSsn(String srcFasSsn) {
		this.srcFasSsn = srcFasSsn;
	}


	public String getSrcFasDate() {
		return srcFasDate;
	}


	public void setSrcFasDate(String srcFasDate) {
		this.srcFasDate = srcFasDate;
	}


	public String getReserved() {
		return reserved;
	}


	public void setReserved(String reserved) {
		this.reserved = reserved;
	}


	public String getSignature() {
		return signature;
	}


	public void setSignature(String signature) {
		this.signature = signature;
	}


	public List<AccountMoveReqItem> getList() {
		return list;
	}


	public void setList(List<AccountMoveReqItem> list) {
		this.list = list;
	}
	
}